-- /run for i=1,40 do local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId=UnitBuff("player",i); if name then print(name.."("..expirationTime..")".." = "..spellId) end end
-- /run for i=1,40 do local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId=UnitDebuff("target",i); if name then print(name.."="..spellId) end end
-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg
  
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")

local tl,tl_rune_any
local pcd,pstart,pisUsable,pnotEnoughMana
local s, d, en
local haveTotem, totemName, startTime, duration, icon
local phaveTotem, ptotemName, pstartTime, pduration
local pduration,pexpire,pstacks
local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId
local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId
local stacks
local i,exist,buff
local noprio=true
local count,iters=0,0
local pcombo,ppower,pground,range
local tl_rune_r,tl_rune_g,tl_rune_b,n_rune_r,n_rune_g,n_rune_b,RuneReady
local ExcludeRunes = {}
local start, finish, c_rune, tl_rune, ReadyRuneFound
local allrunes,numrunes
local update
local pstart,pduration,pruneReady,pruneType
local runeType
local pMain, pOff
local tl_bar

lib.classify =function(u)
	local c = UnitClassification(u)
	if(c == 'elite' or c == 'eliterare') then
		return 'e'
	elseif(c == 'worldboss') then
		return 'b'
	else
		return 'o'
	end
end

lib.GetSetAmount = function(set,updateSetItems)
	if not updateSetItems and cfg.SetItems[set] then
		return cfg.SetItems[set]
	end

	if updateSetItems then
		hedlib.ClearTable( cfg.SetItems )
	end

	local amount = 0
	local setData = cfg.Sets[set]
	if setData then
		for _, itemID in ipairs(setData) do
			if IsEquippedItem(itemID) then
				amount = amount + 1
			end
		end
	end
	cfg.SetItems[set] = amount
	return amount
end

lib.hideRuneFrame=function()
	RuneFrame:Hide()
	RuneFrame.Show = function() end
	RuneFrame.SetPoint = function() end
	RuneFrame.ClearAllPoints = function() end
	RuneFrame.SetAllPoints = function() end
	RuneFrame:UnregisterEvent("RUNE_POWER_UPDATE");
	RuneFrame:UnregisterEvent("RUNE_TYPE_UPDATE");
	RuneFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	RuneFrame:SetScript("OnEvent", nil);
	RuneFrame:SetParent(nil)
end

local lastUpdateBar = 0
lib.OnUpdateBar = function (self, elapsed)
	elapsed = elapsed or 0
	lastUpdateBar = lastUpdateBar + elapsed
	if Heddframe.bar.force or lastUpdateBar > cfg.freq then
		
		Heddframe.bar.cd = Heddframe.bar.cd - (cfg.now - Heddframe.bar.start)
		Heddframe.bar.cd = (Heddframe.bar.cd>0) and Heddframe.bar.cd or 0
		Heddframe.bar.start=cfg.now

		if (Heddframe.bar.cd>0) then
			Heddframe.bar:SetWidth(Heddframe.bar.cd*cfg.scale)
		else
			Heddframe.bar:SetScript("OnUpdate", nil)
			Heddframe.bar:SetWidth(-1)
		end

		lastUpdateBar = 0
		Heddframe.bar.force=nil
		
	end	
end

lib.UpdateBar = function (spell, cd)
	Heddframe.bar.start = cfg.now
	Heddframe.bar.cd = cd or 0
	if spell then
		spell.f:Show()
	end
	Heddframe.bar.force=true
	Heddframe.bar:SetScript("OnUpdate", lib.OnUpdateBar)
	lib.OnUpdateBar()
end

lib.UpdateSpellCD = function(spell)
	if type(spell)=="string" then
		spell=cfg.spells[spell]
	end
	
	if spell then
		spell.cd = spell.cd or 0
		spell.start = spell.start or cfg.now
		spell.isUsable = spell.isUsable or 1
		spell.notEnoughMana = spell.notEnoughMana or nil
		pcd,pstart,pisUsable,pnotEnoughMana = spell.cd,spell.start,spell.isUsable,spell.notEnoughMana
		s, d, en = GetSpellCooldown(spell.name)
		if (GetSpellInfo(spell.name) and s>0 and d>0 and en) then
			spell.cd=d
			spell.start=s
		else
			spell.cd=0
			spell.start=cfg.now
		end
		spell.isUsable,spell.notEnoughMana = IsUsableSpell(spell.name)
		if spell.cd ~= pcd or spell.start ~= pstart or spell.isUsable~=pisUsable or spell.notEnoughMana~=pnotEnoughMana then return(true) end
	end
	return(nil)
end

lib.SpellTL=function(spell)
	if type(spell)=="string" then
		spell=cfg.spells[spell]
	end
	
	if spell then
		tl_spell=spell.cd - (cfg.now - spell.start)
		tl_spell = (tl_spell>=0) and tl_spell or 0
		return tl_spell
	end
	return 0
end

lib.SpellCasting=function(spell)
	if spell then
		if cfg.casting==cfg.spells[spell].name then
			return true, spell
		else
			return nil, cfg.sp_conv[cfg.casting]
		end
	else
		if cfg.casting then
			return true, cfg.sp_conv[cfg.casting]
		else
			return nil
		end
	end
end

lib.SetSpellIcon = function(sname)
	local f = cfg.spells[sname].f
	local icon = cfg.spells[sname].icon
	f:SetWidth(cfg.isize)
	f:SetHeight(cfg.isize)
	f.texture = _G["HEDD_"..sname.."_text"] or f:CreateTexture("HEDD_"..sname.."_text","BACKGROUND")
	f.texture:SetAllPoints(f)
	f.texture:SetTexture(icon)
	f:Hide()
end

lib.HideFrame = function(f)
	if f then f:Hide() end
end

lib.AddSpell = function(...) --(f,spells,sname,ids,noupdate,buff)
	local f,spells,sname,ids,noupdate --,buff
	if type(select(1,...))=="table" then
		f,spells,sname,ids,noupdate=...
	else
		f,spells,sname,ids,noupdate=Heddframe,cfg.spells,...
	end
	
	for index,id in ipairs(ids) do
		local name = GetSpellInfo(id)
		if name and (GetSpellInfo(name) or buff) then
			spells[sname]={}
			spells[sname].f = _G["HEDD_"..sname] or CreateFrame("Frame","HEDD_"..sname,f)
			spells[sname].f:SetAllPoints(f)
			
			spells[sname].name, _, spells[sname].icon, spells[sname].powerCost, spells[sname].isFunnel, spells[sname].powerType, spells[sname].castingTime, spells[sname].minRange, spells[sname].maxRange = GetSpellInfo(id)
			
			lib.SetSpellIcon(sname) --spells[sname].f,spells[sname].icon)
			
			if not noupdate then
				lib.UpdateSpellCD(spells[sname])
			end
			cfg.sp_conv[spells[sname].name]=sname
			
			spells[sname].noupdate=noupdate or nil
			return true
		end
	end
	return false
end

lib.AddRuneSpell = function(...) --f,spells,sname,ids,runemask)
	local f,spells,sname,ids,runemask
	if type(select(1,...))=="table" then
		f,spells,sname,ids,runemask=...
	else
		f,spells,sname,ids,runemask=Heddframe,cfg.spells,...
	end
	for index,id in ipairs(ids) do
		local name = GetSpellInfo(id)
		if name and GetSpellInfo(name) then
			spells[sname]={}
			spells[sname].f = _G["HEDD_"..sname] or CreateFrame("Frame","HEDD_"..sname,f)
			spells[sname].f:SetAllPoints(f)
			
			spells[sname].name, _, spells[sname].icon, spells[sname].powerCost, spells[sname].isFunnel, spells[sname].powerType, spells[sname].castingTime, spells[sname].minRange, spells[sname].maxRange = GetSpellInfo(id)
			lib.SetSpellIcon(sname)
			spells[sname].noupdate=nil
			spells[sname].red = runemask[1]
			spells[sname].green = runemask[2]
			spells[sname].blue = runemask[3]
			spells[sname].numrunes = spells[sname].red + spells[sname].green + spells[sname].blue
			lib.UpdateSpellCD(spells[sname])
			return true
		end
	end
	return false
end

lib.UpdateTotem = function(totemtype)
	totemtype = totemtype or 1
	if not cfg.totems then cfg.totems={} end
	if not cfg.totems[totemtype] then
		haveTotem, totemName, startTime, duration, icon = GetTotemInfo(totemtype)
		cfg.totems[totemtype]={}
		cfg.totems[totemtype].haveTotem = haveTotem
		cfg.totems[totemtype].totemName = totemName
		cfg.totems[totemtype].startTime = startTime
		cfg.totems[totemtype].duration = duration
		return true
	end
	phaveTotem, ptotemName, pstartTime, pduration=cfg.totems[totemtype].haveTotem,cfg.totems[totemtype].totemName,cfg.totems[totemtype].startTime,cfg.totems[totemtype].duration
	cfg.totems[totemtype].haveTotem,cfg.totems[totemtype].totemName,cfg.totems[totemtype].startTime,cfg.totems[totemtype].duration = GetTotemInfo(totemtype)
	
	if phaveTotem~=cfg.totems[totemtype].haveTotem or ptotemName~=cfg.totems[totemtype].totemName or pstartTime~=cfg.totems[totemtype].startTime or pduration~=cfg.totems[totemtype].duration then
		return true
	end
	return nil
end

local tl_totem
lib.GetTotem = function(totemtype)
	if not cfg.totems then lib.UpdateTotem(totemtype) end
	if not cfg.totems[totemtype].haveTotem then return 0 end
	
	tl_totem = cfg.totems[totemtype].duration - (cfg.now-cfg.totems[totemtype].startTime)
	tl_totem = (tl_totem>0) and tl_totem or 0
	
	return tl_totem
end

lib.UpdateAura = function(aura)
	if aura.name then
		pduration,pexpire,pstacks=aura.duration,aura.expire,aura.stacks
		if aura.type=="debuff" then
			name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitDebuff(aura.unit, aura.name)
			if aura.name==name and ((aura.caster=="player" and hedlib.isPlayer(unitCaster)) or aura.caster=="any") then
				aura.duration=duration
				aura.expire=expirationTime
				aura.stacks=count or 1
			else
				aura.duration=0
				aura.expire=0
				aura.stacks=0
			end
		else
			name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitBuff(aura.unit, aura.name)
			if aura.name==name and ((aura.caster=="player" and hedlib.isPlayer(unitCaster)) or aura.caster=="any") then
				aura.duration=duration
				aura.expire=expirationTime
				aura.stacks=count or 1
			else
				aura.duration=0
				aura.expire=0
				aura.stacks=0
			end
		end
		
		if pduration~=aura.duration or pexpire~=aura.expire or pstacks~=aura.stacks then return(true) end
	end
	return(nil)
end

lib.AddAura = function(...) -- auras,sname,id,atype,unit,caster)
	local auras,sname,id,atype,unit,caster
	if type(select(1,...))=="table" then
		auras,sname,id,atype,unit,caster=...
	else
		auras,sname,id,atype,unit,caster=cfg.auras,...
	end
	
	cfg.watchunits[unit]=true
	auras[sname] ={}
	auras[sname].name = GetSpellInfo(id)
	auras[sname].duration=0
	auras[sname].expire=0
	auras[sname].stacks=0
	auras[sname].type=atype
	auras[sname].unit=unit
	auras[sname].caster=caster or "player"
	lib.UpdateAura(auras[sname])
end

local tl_aura, s_aura, notfound_aura, i_aura, n_aura
lib.GetAura = function(auras)
	tl_aura = 0
	s_aura = 0
	for i_aura,n_aura in ipairs(auras) do
		if cfg.auras[n_aura] then
			tl_aura=cfg.auras[n_aura].expire-cfg.now
			tl_aura = (tl_aura>=0) and tl_aura or 0
			if tl_aura>0 then 
				s_aura=cfg.auras[n_aura].stacks
				break
			end
		end
	end
	return tl_aura,s_aura
end


lib.GetAuras = function(aura)
	tl_aura = 0
	s_aura = 0
	i_aura=1
	notfound_aura=true
	while notfound_aura do
		n_aura=aura..i_aura
		if cfg.auras[n_aura] then
			tl_aura = cfg.auras[n_aura].expire-cfg.now
			tl_aura = (tl_aura>=0) and tl_aura or 0
			if tl_aura>0 then 
				s_aura=cfg.auras[n_aura].stacks
				notfound_aura=nil
			end
			i_aura=i_aura+1
		else
			notfound_aura=nil
		end
	end
	return tl_aura,s_aura
end

cfg.Weapons={}
cfg.Weapons.Main, _, _, cfg.Weapons.Off = GetWeaponEnchantInfo()

lib.UpdateWeaponBuffs = function()
	pMain, pOff = cfg.Weapons.Main, cfg.Weapons.Off
	cfg.Weapons.Main, _, _, cfg.Weapons.Off = GetWeaponEnchantInfo()
	if pMain~=cfg.Weapons.Main or pOff~=cfg.Weapons.Off then return true end
	return false
end

local tl_spell
lib.SimpleCDCheck = function (spell,nomanacheck, nousecheck, useGCD, minWait)
	minWait=minWait or 0
	if cfg.spells[spell] and (nomanacheck or not cfg.spells[spell].notEnoughMana) and (nousecheck or cfg.spells[spell].isUsable==1) then
		if useGCD then
			tl_spell=cfg.spells[cfg.gcd].cd - (cfg.now - cfg.spells[cfg.gcd].start)
		else
			tl_spell=cfg.spells[spell].cd - (cfg.now - cfg.spells[spell].start)
		end
		tl_spell = (tl_spell>=0) and tl_spell or 0
		
		if tl_spell==0 or tl_spell<=minWait or tl_spell==cfg.mintime then
			lib.UpdateBar(cfg.spells[spell],tl_spell)
			cfg.cmintime=tl_spell
			return true
		else
			if cfg.cmintime>tl_spell then
				cfg.cmintime=tl_spell
			end
		end
	end
	return nil
end

lib.updateRune = function(rune)
	if not rune then return end
	runeType = GetRuneType(rune)
	if runeType then
		if not cfg.runes then
			cfg.runes={}
		end
		if not cfg.runes[rune] then
			cfg.runes[rune]={}
			cfg.runes[rune].runeType=runeType
			cfg.runes[rune].start, cfg.runes[rune].duration, cfg.runes[rune].runeReady = GetRuneCooldown(rune)
			cfg.Update=true
		else
			pstart,pduration,pruneReady,pruneType = cfg.runes[rune].start, cfg.runes[rune].duration, cfg.runes[rune].runeReady,runeType
			cfg.runes[rune].runeType=runeType
			cfg.runes[rune].start, cfg.runes[rune].duration, cfg.runes[rune].runeReady = GetRuneCooldown(rune)
			if pstart~=cfg.runes[rune].start or pduration~=cfg.runes[rune].duration or pruneReady~=cfg.runes[rune].runeReady or pruneType~=cfg.runes[rune].runeType then
				cfg.Update=true
			end
		end
	end
	return cfg.Update
end

local i_runes

lib.updateAllRunes = function()
	for i_runes = 1, 6 do
		lib.updateRune(i_runes)
	end
	return cfg.Update
end

lib.RuneTypeCD = function(runeType)
	c_rune = 0
	tl_rune=99999
	numrunes=0

	if runeType==1 then
		start,finish=1,2
	elseif runeType==2 then
		start,finish=3,4
	else
		start,finish=5,6
	end
	
	for i_runes = start, finish do
		tl_rune_any =  cfg.runes[i_runes].duration - (cfg.now - cfg.runes[i_runes].start)
		tl_rune_any = (tl_rune_any>=0) and tl_rune_any or 0
		if tl_rune_any==0 then
			numrunes=numrunes+1
		else
			if tl_rune_any<tl_rune then
				tl_rune=tl_rune_any
			end
		end
	end
	return numrunes, tl_rune
end

lib.getruneCD = function(runeType,useDeath)
	c_rune = 0
	tl_rune=99999
	ReadyRuneFound=nil
	
	if runeType==1 then
		start,finish=1,2
	elseif runeType==2 then
		start,finish=3,4
	else
		start,finish=5,6
	end
	
	for i_runes = start, finish do
		if ReadyRuneFound then return 0 end
		if not ExcludeRunes[i_runes] and cfg.runes[i_runes].runeType==runeType then
			tl_rune_any =  cfg.runes[i_runes].duration - (cfg.now - cfg.runes[i_runes].start)
			tl_rune_any = (tl_rune_any>=0) and tl_rune_any or 0
			if tl_rune_any==0 then
				ReadyRuneFound=true
				ExcludeRunes[i_runes]=true
			else
				if tl_rune_any<tl_rune then
					tl_rune=tl_rune_any
					c_rune=i_runes
				end
			end
		end
	end
	if ReadyRuneFound then return 0 end
	
	if useDeath then
		for i_runes = 1, 6 do
			if ReadyRuneFound then return 0 end
			if not ExcludeRunes[i_runes] and cfg.runes[i_runes].runeType==4 then
				tl_rune_any =  cfg.runes[i_runes].duration - (cfg.now - cfg.runes[i_runes].start)
				tl_rune_any = (tl_rune_any>=0) and tl_rune_any or 0
				if tl_rune_any==0 then
					ReadyRuneFound=true
					ExcludeRunes[i_runes]=true
				else
					if tl_rune_any<tl_rune then
						tl_rune=tl_rune_any
						c_rune=i_runes
					end
				end
			end
		end	
	end
	if ReadyRuneFound then return 0 end
	ExcludeRunes[c_rune]=true
	
	return tl_rune
end

lib.RuneCDCheck = function (spell,useDeath,twospells,useGCD,minWait)
	minWait=minWait or 0
	ExcludeRunes = {}

	if cfg.spells[spell] then
		if useGCD and cfg.gcd then
			tl_spell=cfg.spells[cfg.gcd].cd - (cfg.now - cfg.spells[cfg.gcd].start)
		else
			tl_spell=cfg.spells[spell].cd - (cfg.now - cfg.spells[spell].start)
		end
		tl_spell = (tl_spell>=0) and tl_spell or 0
		
		tl_rune_r,tl_rune_g,tl_rune_b = 0,0,0
		n_rune_r,n_rune_g,n_rune_b = 0,0,0
		
		for j = 1,2 do
			if cfg.spells[spell].red==1 then
				tl_rune_r=lib.getruneCD(1,useDeath)
				if ReadyRuneFound then n_rune_r = n_rune_r+1 end
			else
				n_rune_r=2
			end
		
			if cfg.spells[spell].green==1 then
				tl_rune_g=lib.getruneCD(2,useDeath)
				if ReadyRuneFound then n_rune_g = n_rune_g+1 end
			else
				n_rune_g=2
			end
		
			if cfg.spells[spell].blue==1 then
				tl_rune_b=lib.getruneCD(3,useDeath)
				if ReadyRuneFound then n_rune_b = n_rune_b+1 end
			else
				n_rune_b=2
			end
			
			if not twospells then break end
		end
		
		if twospells and n_rune_r==2 and n_rune_g==2 and n_rune_b==2 then
			lib.UpdateBar(cfg.spells[spell],0)
			return true
		end
		
		if n_rune_r>0 and n_rune_g>0 and n_rune_b>0 then
			tl_spell=tl_spell
		else
			if tl_spell<tl_rune_r then tl_spell=tl_rune_r end
			if tl_spell<tl_rune_g then tl_spell=tl_rune_g end
			if tl_spell<tl_rune_b then tl_spell=tl_rune_b end
		end
		
		if tl_spell==0 or tl_spell<=minWait or tl_spell==cfg.mintime then
			lib.UpdateBar(cfg.spells[spell],tl_spell)
			cfg.cmintime=tl_spell
			return true
		else
			if cfg.cmintime>tl_spell then
				cfg.cmintime=tl_spell
			end
		end

--[[		if tl_spell==0 then
			lib.UpdateBar(cfg.spells[spell],0)
			return true
		else
			if cfg.mintime==tl_spell then
				lib.UpdateBar(cfg.spells[spell],tl_spell)
				return true
			else
				if cfg.cmintime>tl_spell then
					cfg.cmintime=tl_spell
				end
			end
		end]]
	end
	return nil
end

lib.RuneSpellTL=function(spell,useDeath,useGCD)
	ExcludeRunes = {}
	if cfg.spells[spell] then
		if useGCD then
			tl_spell=cfg.spells[cfg.gcd].cd - (cfg.now - cfg.spells[cfg.gcd].start)
		else
			tl_spell=cfg.spells[spell].cd - (cfg.now - cfg.spells[spell].start)
		end
		tl_spell = (tl_spell>=0) and tl_spell or 0
		
		tl_rune_r,tl_rune_g,tl_rune_b = 0,0,0
		n_rune_r,n_rune_g,n_rune_b = 0,0,0

		if cfg.spells[spell].red==1 then
			tl_rune_r=lib.getruneCD(1,useDeath)
			if ReadyRuneFound then n_rune_r = n_rune_r+1 end
		else
			n_rune_r=1
		end
		
		if cfg.spells[spell].green==1 then
			tl_rune_g=lib.getruneCD(2,useDeath)
			if ReadyRuneFound then n_rune_g = n_rune_g+1 end
		else
			n_rune_g=1
		end
		
		if cfg.spells[spell].blue==1 then
			tl_rune_b=lib.getruneCD(3,useDeath)
			if ReadyRuneFound then n_rune_b = n_rune_b+1 end
		else
			n_rune_b=1
		end
			
		if n_rune_r>0 and n_rune_g>0 and n_rune_b>0 then
			tl_spell=tl_spell
		else
			if tl_spell<tl_rune_r then tl_spell=tl_rune_r end
			if tl_spell<tl_rune_g then tl_spell=tl_rune_g end
			if tl_spell<tl_rune_b then tl_spell=tl_rune_b end
		end

		return tl_spell
	end
	return 0
end

lib.UseTotem = function (totem,totemname)
	if cfg.spells[totemname] and cfg.spells[totemname].isUsable==1 and not cfg.spells[totemname].notEnoughMana and totem then
		tl_spell = cfg.spells[totemname].cd - (cfg.now - cfg.spells[totemname].start)
		tl_spell = (tl_spell>=0) and tl_spell or 0
		
		tl_aura	= totem.duration - (cfg.now - totem.startTime)
		tl_aura = (tl_aura>=0) and tl_aura or 0
		
		if tl_spell<tl_aura then
			tl_spell=tl_aura
		end
			
		if tl_spell==0 then
			lib.UpdateBar(cfg.spells[totemname],0)
			return true
		else
			if cfg.mintime==tl_spell then
				lib.UpdateBar(cfg.spells[totemname],tl_spell)
				return true
			else
				if cfg.cmintime>tl_spell then
					cfg.cmintime=tl_spell
				end
			end
		end
	end
	return nil
end

local i_spell, i_case, n_case
lib.SetPriority = function()
--	print(cfg.now)
	for i_spell in pairs(cfg.spells) do
		lib.HideFrame(cfg.spells[i_spell].f)
	end

	cfg.mintime = 0
	cfg.cmintime = cfg.maxmintime
	noprio=true
	count,iters=0,0

	while noprio do
		count=count+1
		for i_case, n_case in pairs(cfg.plist) do
			if cfg.case[n_case] then
--				iters=iters+1
				if cfg.case[n_case]() then
					noprio=nil
					break
				end
			else
				if lib.SimpleCDCheck(n_case) then
					noprio=nil
					break
				end
			end
		end
		if cfg.cmintime==cfg.maxmintime or count>cfg.numcase then
			lib.UpdateBar(nil)
			noprio=nil
			break
		end
		if noprio==nil then
			break
		end
		cfg.mintime=cfg.cmintime
	end
	Heddframe.bar.force=true
end

lib.inrange = function(spell)
	spell = cfg.spells[spell] and cfg.spells[spell].name or spell
	range=IsSpellInRange(spell,"target")
	if range==0 then return nil end
	return true
end

lib.bdcolor = function(f,color)
	if color then
		f:SetBackdropColor(unpack(color))
		f:SetBackdropBorderColor(unpack(color))
		f:Show()
	else
		f:Hide()
	end
end

lib.ComboUpdate = function()
	pcombo = cfg.combo
	cfg.combo = GetComboPoints('player', 'target')
	if pcombo~=cfg.combo then
		return true
	end
	return nil
end

lib.HolyPowerUpdate = function()
	ppower = cfg.holy
	cfg.holy = UnitPower("player" , SPELL_POWER_HOLY_POWER)
	if ppower~=cfg.holy then
		return true
	end
	return nil
end

cfg.onGround = true
lib.GroundUpdate = function()
	pground=cfg.onGround
	if IsFalling() or IsFlying() then
		cfg.onGround=nil
	else
		cfg.onGround=true
	end
	
	if pground~=cfg.onGround then
		return true
	end
	return nil
end

ns.lib = lib